<?php 

/**
 * Class to extend the backend with a tca user field 
 * @package				Tx_Cbgooglemaps
 * @path 				Tx_Cbgooglemaps_Controller_MapController.php
 * @version				1.0: MapController.php,  03.07.2011
 * @copyright 			(c)2011 Christian Brinert
 * @author 				Christian Brinkert <christian.brinkert@googlemail.com>
 */
class Tx_Cbgooglemaps_Controller_MapController extends Tx_Extbase_MVC_Controller_ActionController {

	
	public function initializeAction() {
		// store content element data to local property
		$this->ceData = $this->request->getContentObjectData();	
	
        // add javascript file  
        $this->response->addAdditionalHeaderData( 
        	'<script src="'.$this->settings['googleapi']['uri'].'" type="text/javascript"></script>');

	}  
	
	
	public function indexAction()
	{				
		// assign contents to the view
		$this->view->assign('contentId', $this->ceData['uid']);
		
		// assign width and height of map
		if (0 < (int) $this->settings['cbgmMapWidth'])
			$width = $this->settings['cbgmMapWidth'];
		else 
			$width = $this->settings['display']['width'];
		$this->view->assign('width', $width);
		
		
		if (0 < (int) $this->settings['cbgmMapHeight'])
			$height = $this->settings['cbgmMapHeight'];
		else 
			$height = $this->settings['display']['height'];
		$this->view->assign('height', $height);
		
		// assign pin description text
		$infoText = ($this->settings['cbgmDescription']);
		$this->view->assign('infoText', urlencode($infoText));
		
		// assign location (longitude and latitude) to the view
		$this->view->assign('latitude', (float) $this->settings['cbgmLatitude']);
		$this->view->assign('longitude', (float) $this->settings['cbgmLongitude']);
		
		// assign map zoom level to the view ,if given value is valid
		if (0 <= (int) $this->settings['cbgmScaleLevel'] && !empty($this->settings['cbgmScaleLevel']))	
			$mapZoom = (int) $this->settings['cbgmScaleLevel'];
		else 
			$mapZoom = $this->settings['display']['zoom'];			 
		$this->view->assign('mapZoom', $mapZoom);
		
		// assign map type to the view, if given value is valid
		if (in_array((string) $this->settings['cbgmMapType'], 
			preg_split("/[\s]*[,][\s]*/", $this->settings['valid']['mapTypes'])))
			$mapType = $this->settings['cbgmMapType'];
		else 
			$mapType = $this->settings['display']['mapType'];
		$this->view->assign('mapType', $mapType);

		// assign navigation controls to the view
		if (in_array((string) $this->settings['cbgmNavigationControl'], 
			preg_split("/[\s]*[,][\s]*/", $this->settings['valid']['navigationControl'])))
			$navigationControl = $this->settings['cbgmNavigationControl'];
		else 
			$navigationControl = $this->settings['display']['navigationControl'];
		$this->view->assign('mapControl', $navigationControl);

	}
}